VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "DataBuffer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Declare Sub CpyMem Lib "kernel32" Alias "RtlMoveMemory" ( _
    pDst As Any, pSrc As Any, ByVal cBytes As Long _
)

Private m_btBuffer()        As Byte
Private m_lngBufferBytes    As Long

Public Sub SetBufferSize(ByVal Bytes As Long, ByVal PreserveData As Boolean)
    If Bytes <= 0 Then
        Erase m_btBuffer
        m_lngBufferBytes = 0
    Else
        If PreserveData Then
            ReDim Preserve m_btBuffer(Bytes - 1) As Byte
        Else
            ReDim m_btBuffer(Bytes - 1) As Byte
        End If
    
        m_lngBufferBytes = Bytes
    End If
End Sub

Public Property Get BufferSize() As Long
    BufferSize = m_lngBufferBytes
End Property

Public Property Get BufferPointer() As Long
    BufferPointer = VarPtr(m_btBuffer(0))
End Property

Public Sub WriteToBuffer(ByVal ByteOffset As Long, ByVal ptr As Long, ByVal Bytes As Long)
    If (ByteOffset + Bytes > BufferSize) Or (Bytes <= 0) Then
        Err.Raise 6
    Else
        CpyMem m_btBuffer(ByteOffset), ByVal ptr, Bytes
    End If
End Sub

Public Sub PullToFront(ByVal Bytes As Long)
    CpyMem m_btBuffer(0), m_btBuffer(BufferSize - Bytes), Bytes
End Sub
